diff --git a/Documentation/btrfs-convert.txt b/Documentation/btrfs-convert.txt
index 1eff0bf..11d6044 100644
--- a/Documentation/btrfs-convert.txt
+++ b/Documentation/btrfs-convert.txt
@@ -31,18 +31,6 @@ EXIT STATUS
 *btrfs-convert* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-debug-tree.txt b/Documentation/btrfs-debug-tree.txt
index bfc8aa4..23fc115 100644
--- a/Documentation/btrfs-debug-tree.txt
+++ b/Documentation/btrfs-debug-tree.txt
@@ -33,18 +33,6 @@ EXIT STATUS
 *btrfs-debug-tree* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-find-root.txt b/Documentation/btrfs-find-root.txt
index a360f8f..c934b4c 100644
--- a/Documentation/btrfs-find-root.txt
+++ b/Documentation/btrfs-find-root.txt
@@ -28,18 +28,6 @@ EXIT STATUS
 *btrfs-find-root* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-image.txt b/Documentation/btrfs-image.txt
index 155194a..b7751f9 100644
--- a/Documentation/btrfs-image.txt
+++ b/Documentation/btrfs-image.txt
@@ -56,18 +56,6 @@ EXIT STATUS
 *btrfs-image* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-map-logical.txt b/Documentation/btrfs-map-logical.txt
index a8710bf..a3d110c 100644
--- a/Documentation/btrfs-map-logical.txt
+++ b/Documentation/btrfs-map-logical.txt
@@ -32,18 +32,6 @@ EXIT STATUS
 *btrfs-map-logical* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-show-super.txt b/Documentation/btrfs-show-super.txt
index 6fee0f1..1646be3 100644
--- a/Documentation/btrfs-show-super.txt
+++ b/Documentation/btrfs-show-super.txt
@@ -45,18 +45,6 @@ EXIT STATUS
 *btrfs-show-super* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfs-zero-log.txt b/Documentation/btrfs-zero-log.txt
index 0a8d3e3..498ecd6 100644
--- a/Documentation/btrfs-zero-log.txt
+++ b/Documentation/btrfs-zero-log.txt
@@ -40,18 +40,6 @@ EXIT STATUS
 *btrfs-zero-log* will return 0 if no error happened.
 Other exit code means some problems happened.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)
diff --git a/Documentation/btrfstune.txt b/Documentation/btrfstune.txt
index bf44bdf..56cf66b 100644
--- a/Documentation/btrfstune.txt
+++ b/Documentation/btrfstune.txt
@@ -31,18 +31,6 @@ EXIT STATUS
 *btrfstune* will return 0 if no error happened.
 If any problems happened, 1 will be returned.
 
-AUTHOR
-------
-Written by Shilong Wang and Wenruo Qu.
-
-COPYRIGHT
----------
-Copyright (C) 2013 FUJITSU LIMITED.
-
-License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>.
-
-This is free software: you are free  to  change  and  redistribute  it. There is NO WARRANTY, to the extent permitted by law.
-
 SEE ALSO
 --------
 `mkfs.btrfs`(8)